# Help plugins/register/

Here are plugins to control count of simultanous backups.

For SSH based backup of more than - let's say - 10 servers you should
think about to enable that feature.

A backup will register before starting a file transfer
and unregister when the backup is finished.

Plugins:

* ssh.sh - execute a remote command via ssh on backup target using backup user

The configuration is in `[APPDIR]/jobs/transfer.job`

```text
# register for a backup slot
storage-register = [plugin]
```

## Plugins

### ssh

Executes a ssh command. Its limitation is that it automatically connects
with the same user, its privatekey and the same host like ssh backend.

You need just one additional config entry for the remote command to execute.

Example config:

```text
# register for a backup slot
storage-register = ssh
storage-registercmd = ./storage_helper.sh
```

See the project https://git-repo.iml.unibe.ch/iml-open-source/iml-backup-server
for a bash implementation of a counter with `storage_helper.sh`.

## Developer notes

You can create another registration process. You need to add your own
register plugin `[plugin].sh` that contains these functions:

* registerBackupSlot \
  A command on a control instance can handles the counts. If the limit is reached it sends returncode <> 0.
  The backup client will wait a random time before asking for a free slot again.

* unregisterBackupSlot \
  A backup sends an unregister command to unlock a given slot.
  The control instance needs to free the slot.

* statusBackupSlot \
  Show currently used slots.

The file needs no execute permissions - read permissions are enough i.e. `chmod 644 [plugin].sh`.
